#ifndef SCHED_H_
#define SCHED_H_

/* A simple scheduler for a virtual machine. */

typedef enum {
	SCHED_UNKNOWN,
	SCHED_IDLE,
	SCHED_RUNNING_INTR,
	SCHED_RUNNING_CYCLE,
	SCHED_RUNNING_BG
} sched_state_t;

/* Schedule a new task to execute. */
void	sched_tasks(struct vm *machine);

/* Delete a current executing task from a  scheduler stack. */
void	sched_current_del(struct vm *machine);

/* Put a new task to the scheduler stack top. */
void	sched_put_task(struct task *task);

/* Get a current task. */
struct task *sched_get_current();

/* Get current scheduler state.  */
sched_state_t sched_get_state();

#endif /* SCHED_H_ */
